#!/usr/bin/env python

import os, sys, shutil
from subprocess import Popen, PIPE

# check if AMBERHOME is defined and exit if not...
amberhome = os.getenv("AMBERHOME")
if not amberhome:
   print '\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
   print '!!! No AMBERHOME environment variable defined !!!'
   print '!!!        This means trouble...Bye           !!!'
   print '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'          
   sys.exit(-1)
else:
   print '\nAMBERHOME environment variable points to:'
   print '     %s'%amberhome
# the following executables must be in the path for AmberLite to work:
   for prog in ['tleap', 'sqm', 'antechamber', 'pbsa', 'parmchk', 'nab']:
      try:
         Popen([prog, '-h'], stdin = PIPE, stdout = PIPE, stderr = PIPE)
      except OSError,e:
         print '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         print '!!! %s does not seem to be in the path...'%prog
         print '!!! You should correct this before retrying'
         print '!!! the AmberLite installation!'
         print '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         sys.exit(-1)
# everything OK
print 'All required Amber Tools routines are available...'

# create ./bin directory if it does not exist
if not os.path.exists('./bin'):
   print 'Now creating ./bin directory...'
   os.makedirs('./bin')
   
#compile the nab sources
os.chdir('./bin')
print 'Compiling NAB sources and ...'
for file in ['ffgbsa', 'minab', 'mdnab']:
   compile = Popen(['nab', '../src/%s.nab'%file, '-o %s'%file], 
                   stdin = PIPE, stdout = PIPE, stderr = PIPE)
   compile.wait()
   os.remove('../src/%s.c'%file)
# symlink the python scripts
print 'creating symbolic links to Python scripts...'
if not os.path.exists('pymdpbsa'):
   os.symlink('../python/pymdpbsa', 'pymdpbsa')
if not os.path.exists('pytleap'):
   os.symlink('../python/pytleap', 'pytleap')
# reminder to add the amberlite/bin to the PATH
print '\n=================================================='
print '        Do not forget to add the directory'
print '        %s'%os.getcwd()
print '                 to your PATH...'
print '=================================================='
