# include <stdio.h>
# include <math.h>
# include <ctype.h>
# include <stdlib.h>
# include <string.h>
# define MAXCHAR 256 
# define COLORTEXT "YES" 
# define PI 3.1415926 
# define debug 0
typedef struct {
	char name[10];
	char type[10];
	double mass;
	double pol;
} ATOM;
typedef struct {
	int flag;
	char at1[10];
	char at2[10];
	double len;
	double force;
} BOND;
typedef struct {
	int flag;
	char at1[10];
	char at2[10];
	char at3[10];
	double angle;
	double force;
} ANGLE;
typedef struct {
	int flag;
	int type;
	char at1[10];
	char at2[10];
	char at3[10];
	char at4[10];
	double periodicity;
	double phase;
	double force;
} TOR;

int i,j,k=0;
int atomnum = 0;
int typenum = 0;
int btnum = 0;
int atnum = 0;
int ttnum = 0;

int btnum2 = 0;
int atnum2 = 0;
int ttnum2 = 0;


ATOM *atom;
BOND *bond;
ANGLE *angle;
TOR *tor;

char pfilename[MAXCHAR];
char ofilename[MAXCHAR];
FILE *fptop,  *fpout ;

char line[MAXCHAR];
char tmpchar1[MAXCHAR], tmpchar2[MAXCHAR], tmpchar3[MAXCHAR];
int tmpint1, tmpint2;


void rtopparm() {
int tmpint1, tmpint2, tmpint3, tmpint4, tmpint5;
for(;;) {
	line[7] = ' ';
	line[15] = ' ';
	line[23] = ' ';
	line[31] = ' ';
	line[39] = ' ';
	line[47] = ' ';
	line[55] = ' ';
	line[63] = ' ';
	line[71] = ' ';
	line[79] = ' ';
	if(fgets(line, MAXCHAR, fptop)==NULL) break;
    	sscanf(line, "%s%s", tmpchar1, tmpchar2);
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("POINTERS", tmpchar2) == 0) {
    		fgets(line, MAXCHAR, fptop);
    		fgets(line, MAXCHAR, fptop);
		sscanf(line, "%d%d", &atomnum, &typenum);
    		fgets(line, MAXCHAR, fptop);
		sscanf(line, "%d%d%d%d%d%d%d%d", &tmpint1, &tmpint2, &tmpint3, &tmpint4, &tmpint5, &btnum, &atnum, &ttnum);
    	} 
}
}

void rtopatom() {
char str[10];
double v[5];
int numatom;
int tmpint;
int flag = -999;

for(;;) {
	line[7] = ' ';
	line[15] = ' ';
	line[23] = ' ';
	line[31] = ' ';
	line[39] = ' ';
	line[47] = ' ';
	line[55] = ' ';
	line[63] = ' ';
	line[71] = ' ';
	line[79] = ' ';
	if(fgets(line, MAXCHAR, fptop)==NULL) break;
    	sscanf(line, "%s%s", tmpchar1, tmpchar2);
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("ATOM_NAME", tmpchar2) == 0) {
		flag = 0; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("MASS", tmpchar2) == 0) {
		flag = 2; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("AMBER_ATOM_TYPE", tmpchar2) == 0) {
		flag = 4; 
		continue; 
    	} 

    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("POLARIZABILITY", tmpchar2) == 0) {
		flag = 6; 
		continue; 
    	} 

    	if(flag==0) {flag = 1; i= 0; continue; }
    	if(flag==2) {flag = 3; i =0 ; continue; }
    	if(flag==4) {flag = 5; i =0 ; continue; }
    	if(flag==6) {flag = 7; i =0 ; continue; }

    	if(flag ==1) {
		for(j=0;j<20;j++) {
			strcpy(str, "");
			str[0] = '\0';
			str[0]=line[j*4];
			if(line[j*4+1] == ' ' || line[j*4+1] == '\0' || line[j*4+1] == '\n')
				str[1] = '\0';
			else {
				str[1]=line[j*4+1];
				if(line[j*4+2] == ' ' || line[j*4+2] == '\0' || line[j*4+2] == '\n')
					str[2] = '\0';
				else {
					str[2]=line[j*4+2];
					if(line[j*4+3] == ' ' || line[j*4+3] == '\0' || line[j*4+3] == '\n')
						str[3] = '\0';
					else {
						str[3]=line[j*4+3];
						str[4]= '\0';
					}
				}
			}
			strcpy(atom[i].name, str);
			i++;
			if(i>=atomnum) {
				flag = -999;
				break;
			}
		}
    	}
    	if(flag ==3) {
		sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
		for(j=0;j<5;j++) {
			atom[i].mass = v[j];	
			i++;
			if(i>=atomnum) {
				flag = -999;
				break;
			}
		} 
	}
    	if(flag ==5) {
                for(j=0;j<20;j++) {
                        strcpy(str, "");
                        str[0] = '\0';
                        str[0]=line[j*4];
                        if(line[j*4+1] == ' ' || line[j*4+1] == '\0' || line[j*4+1] == '\n')
                                str[1] = '\0';
                        else {
                                str[1]=line[j*4+1];
                                if(line[j*4+2] == ' ' || line[j*4+2] == '\0' || line[j*4+2] == '\n')
                                        str[2] = '\0';
                                else {
                                        str[2]=line[j*4+2];
                                        if(line[j*4+3] == ' ' || line[j*4+3] == '\0' || line[j*4+3] == '\n')
                                                str[3] = '\0';
                                        else {
                                                str[3]=line[j*4+3];
                                                str[4]= '\0';
                                        }
                                }
                        }
                        strcpy(atom[i].type, str);
                        i++;
                        if(i>=atomnum) { 
                                flag = -999;
                                break;
                        }
                }

    	}
    	if(flag ==7) {
		sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
		for(j=0;j<5;j++) {
			atom[i].pol = v[j];	
			i++;
			if(i>=atomnum) {
				flag = -999;
				break;
			}
		} 
	}
}
if(debug == 1) {
	for(i=0;i<atomnum;i++) 
		printf("ATOM %5d %5s %5s %9.4lf %9.4lf\n", i+1, atom[i].name, atom[i].type, atom[i].mass, atom[i].pol);
}
}

void rtopff() {
int tmpint;
int flag = -999;
int tortype;
double v[5];
int at1, at2, at3, at4;

for(;;) {
	line[7] = ' ';
	line[15] = ' ';
	line[23] = ' ';
	line[31] = ' ';
	line[39] = ' ';
	line[47] = ' ';
	line[55] = ' ';
	line[63] = ' ';
	line[71] = ' ';
	line[79] = ' ';
	if(fgets(line, MAXCHAR, fptop)==NULL) break;
    	sscanf(line, "%s%s", tmpchar1, tmpchar2);
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("BOND_FORCE_CONSTANT", tmpchar2) == 0) {
		flag = 0; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("BOND_EQUIL_VALUE", tmpchar2) == 0) {
		flag = 2; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("ANGLE_FORCE_CONSTANT", tmpchar2) == 0) {
		flag = 4; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("ANGLE_EQUIL_VALUE", tmpchar2) == 0) {
		flag = 6; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("DIHEDRAL_FORCE_CONSTANT", tmpchar2) == 0) {
		flag = 8; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("DIHEDRAL_PERIODICITY", tmpchar2) == 0) {
		flag = 10; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("DIHEDRAL_PHASE", tmpchar2) == 0) {
		flag = 12; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("BONDS_INC_HYDROGEN", tmpchar2) == 0) {
		flag = 14; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("BONDS_WITHOUT_HYDROGEN", tmpchar2) == 0) {
		flag = 16; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("ANGLES_INC_HYDROGEN", tmpchar2) == 0) {
		flag = 18; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("ANGLES_WITHOUT_HYDROGEN", tmpchar2) == 0) {
		flag = 20; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("DIHEDRALS_INC_HYDROGEN", tmpchar2) == 0) {
		flag = 22; 
		continue; 
    	} 
    	if (strcmp("%FLAG", tmpchar1) == 0 &&strcmp("DIHEDRALS_WITHOUT_HYDROGEN", tmpchar2) == 0) {
		flag = 24; 
		continue; 
    	} 

    	if(flag==0) {flag = 1; i =0 ; continue; }
    	if(flag==2) {flag = 3; i =0 ; continue; }
    	if(flag==4) {flag = 5; i =0 ; continue; }
    	if(flag==6) {flag = 7; i =0 ; continue; }
    	if(flag==8) {flag = 9; i =0 ; continue; }
    	if(flag==10) {flag = 11; i =0 ; continue; }
    	if(flag==12) {flag = 13; i =0 ; continue; }
    	if(flag==14) {flag = 15; i =0 ; k=0;  continue; }
    	if(flag==16) {flag = 17; i =0 ; k=0;  continue; }
    	if(flag==18) {flag = 19; i =0 ; k=0;  continue; }
    	if(flag==20) {flag = 21; i =0 ; k=0;  continue; }
    	if(flag==22) {flag = 23; i =0 ; k=0;  continue; }
    	if(flag==24) {flag = 25; i =0 ; k=0;  continue; }

        if(flag ==1) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        bond[i].force = v[j];
                        i++;
                        if(i>=btnum) {
                                flag = -999;
                                break;
                        }
                }
        }

        if(flag ==3) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        bond[i].len = v[j];
			bond[i].flag = 0;
                        i++;
                        if(i>=btnum) {
                                flag = -999;
                                break;
                        }
                }
        }

        if(flag ==5) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        angle[i].force = v[j];
                        i++;
                        if(i>=atnum) {
                                flag = -999;
                                break;
                        }
                }
        }

        if(flag ==7) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        angle[i].angle = v[j];
			angle[i].flag = 0;
                        i++;
                        if(i>=atnum) {
                                flag = -999;
                                break;
                        }
                }
        }

        if(flag ==9) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        tor[i].force = v[j];
                        i++;
                        if(i>=ttnum) {
                                flag = -999;
                                break;
                        }
                }
        }

        if(flag ==11) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        tor[i].periodicity = v[j];
                        i++;
                        if(i>=atnum) {
                                flag = -999;
                                break;
                        }
                }
        }
        if(flag ==13) {
                sscanf(line, "%lf%lf%lf%lf%lf", &v[0], &v[1], &v[2], &v[3], &v[4]);
                for(j=0;j<5;j++) {
                        tor[i].phase = v[j];
			tor[i].flag = -1;
                        i++;
                        if(i>=ttnum) {
                                flag = -999;
                                break;
                        }
                }
        }
        if(flag ==15 || flag == 17) {
                j = 0;
                while(j <= 10) {
                        j++;
                        if(line[j*8-1] <='9' && line[j*8-1]>='0')
                                sscanf(&line[8*j-8], "%d", &tmpint);
                        else break;
                        if(k==0) {
                                at1 = tmpint/3;
                                k=1;
                                continue;
                        }
                        if(k==1) {
                                at2 = tmpint/3;
                                k=2;
                                continue;
                        }
                        if(k==2) {
                                k=0;
				if(bond[tmpint-1].flag == 1) continue;
				strcpy(bond[tmpint-1].at1, atom[at1].type);	
				strcpy(bond[tmpint-1].at2, atom[at2].type);	
				bond[tmpint-1].flag = 1;
				btnum2++;
				if(btnum2 >= btnum) {
					flag = -999;
					break;
				}
                                continue;
                        }
                } 
	}
	
        if(flag ==19 || flag == 21) {
                j = 0;
                while(j <= 10) {
                        j++;
                        if(line[j*8-1] <='9' && line[j*8-1]>='0')
                                sscanf(&line[8*j-8], "%d", &tmpint);
                        else break;
                        if(k==0) {
                                at1 = tmpint/3;
                                k=1;
                                continue;
                        }
                        if(k==1) {
                                at2 = tmpint/3;
                                k=2;
                                continue;
                        }
                        if(k==2) {
                                at3 = tmpint/3;
                                k=3;
                                continue;
                        }
                        if(k==3) {
                                k=0;
				if(angle[tmpint-1].flag == 1) continue;
                                strcpy(angle[tmpint-1].at1, atom[at1].type);
                                strcpy(angle[tmpint-1].at2, atom[at2].type);
                                strcpy(angle[tmpint-1].at3, atom[at3].type);
                                angle[tmpint-1].flag = 1;
                                atnum2++;
                                if(atnum2 >= atnum) {
                                        flag = -999;
                                        break;
                                }
                                continue;
                        }
                }
        }

        if(flag ==23 || flag == 25) {
                j = 0;
		tortype = 0;
                while(j <= 10) {
                        j++;
                        if(line[j*8-1] <='9' && line[j*8-1]>='0')
                                sscanf(&line[8*j-8], "%d", &tmpint);
                        else break;
			
                        if(k==0) {
                                at1 = fabs(tmpint)/3;
                                k=1;
                                continue;
                        }
                        if(k==1) {
                                at2 = fabs(tmpint)/3;
                                k=2;
                                continue;
                        }
                        if(k==2) {
                                at3 = fabs(tmpint)/3;
                                k=3;
                                continue;
                        }
                        if(k==3) {
				if(tmpint < 0) tortype = 1;
                                at4 = fabs(tmpint)/3;
                                k=4;
                                continue;
                        }
                        if(k==4) {
                                k=0;
				if(tor[tmpint-1].flag == 1) continue;
                                strcpy(tor[tmpint-1].at1, atom[at1].type);
                                strcpy(tor[tmpint-1].at2, atom[at2].type);
                                strcpy(tor[tmpint-1].at3, atom[at3].type);
                                strcpy(tor[tmpint-1].at4, atom[at4].type);
                                tor[tmpint-1].flag = 1;
				tor[tmpint-1].type = tortype;
                                ttnum2++;
                                if(ttnum2 >= ttnum) {
                                        flag = -999;
                                        break;
                                }
                                continue;
                        }
                }
        }
}
}

void write(void) {
int i,j;
int suc;
fprintf(fpout, "remark goes here\n");
fprintf(fpout, "MASS\n");
for(i=0;i<atomnum;i++) {
	suc = 1;
	for(j=0;j<i;j++) {
		if(strcmp(atom[i].type, atom[j].type) == 0) {
			suc = 0;
			break;
		}
	}
	if(suc == 1) 
		fprintf(fpout, "%-4s%10.3lf%10.3lf\n", atom[i].type, atom[i].mass, atom[i].pol);
}
fprintf(fpout, "\n");
fprintf(fpout, "BOND\n");
for(i=0;i<btnum;i++){
	if(strcmp(bond[i].at1, bond[i].at2) > 0) 
		fprintf(fpout, "%-2s-%-2s%10.3lf%10.3lf\n", bond[i].at2, bond[i].at1, bond[i].force, bond[i].len);
	else
		fprintf(fpout, "%-2s-%-2s%10.3lf%10.3lf\n", bond[i].at1, bond[i].at2, bond[i].force, bond[i].len);
}

fprintf(fpout, "\n");
fprintf(fpout, "ANGLE\n");
for(i=0;i<atnum;i++){
	if(strcmp(angle[i].at1, angle[i].at3) > 0) 
		fprintf(fpout, "%-2s-%-2s-%-2s%10.3lf%10.3lf\n", angle[i].at3, angle[i].at2, angle[i].at1, angle[i].force, angle[i].angle * 180.0/PI);
	else
		fprintf(fpout, "%-2s-%-2s-%-2s%10.3lf%10.3lf\n", angle[i].at1, angle[i].at2, angle[i].at3, angle[i].force, angle[i].angle * 180.0/PI);
}

fprintf(fpout, "\n");
fprintf(fpout, "DIHE\n");
for(i=0;i<ttnum;i++){
	if(tor[i].type == 1) continue;
	suc = 0;
	if(i<ttnum-1 && tor[i+1].type != 1) {
		if(strcmp(tor[i].at1, tor[i+1].at1) == 0 &&
		   strcmp(tor[i].at2, tor[i+1].at2) == 0 &&
		   strcmp(tor[i].at3, tor[i+1].at3) == 0 &&
		   strcmp(tor[i].at4, tor[i+1].at4) == 0)
			suc = 1;
		if(suc == 0) {
			if(strcmp(tor[i].at1, tor[i+1].at4) == 0 &&
		   	   strcmp(tor[i].at2, tor[i+1].at3) == 0 &&
		           strcmp(tor[i].at3, tor[i+1].at2) == 0 &&
		           strcmp(tor[i].at4, tor[i+1].at1) == 0)
					suc = 1;
		}
	}
	if(strcmp(tor[i].at1, tor[i].at4) > 0) {
		if(suc == 1) 
			fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at4, tor[i].at3, tor[i].at2, tor[i].at1, 1, tor[i].force, tor[i].phase*180/PI, -tor[i].periodicity);
		else
			fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at4, tor[i].at3, tor[i].at2, tor[i].at1, 1, tor[i].force, tor[i].phase*180/PI, tor[i].periodicity);
	}
	else {
		if(suc == 1)
			fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at1, tor[i].at2, tor[i].at3, tor[i].at4, 1, tor[i].force, tor[i].phase*180/PI, -tor[i].periodicity);
		else
			fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at1, tor[i].at2, tor[i].at3, tor[i].at4, 1, tor[i].force, tor[i].phase*180/PI, tor[i].periodicity);
	}
}

fprintf(fpout, "\n");
fprintf(fpout, "IMPROPER\n");
for(i=0;i<ttnum;i++){
	if(tor[i].type == 0) continue;
	if(strcmp(tor[i].at1, tor[i].at4) > 0) {
		fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at4, tor[i].at3, tor[i].at2, tor[i].at1, 1, tor[i].force, tor[i].phase*180/PI, tor[i].periodicity);
	}
	else {
		fprintf(fpout, "%-2s-%-2s-%-2s-%-2s%4d%15.3lf%15.3lf%15.3lf\n", tor[i].at1, tor[i].at2, tor[i].at3, tor[i].at4, 1, tor[i].force, tor[i].phase*180/PI, tor[i].periodicity);
	}
}

fprintf(fpout, "\n");
fprintf(fpout, "NONBON\n\n\n");

}


int main(int argc, char *argv[]) {
int i;
/*  readin a topology file and crd file,then save out a mol2 file */
if (strcmp(COLORTEXT, "YES") == 0 || strcmp(COLORTEXT, "yes") == 0) {
	if (argc == 2
		&& (strcmp(argv[1], "-h") == 0
			|| strcmp(argv[1], "-H") == 0)) {
		printf("[31mUsage: toptor -p [0m topology file name\n"
			   "[31m              -o [0m output file name)\n");
		exit(1);
	}
	if (argc != 5) {
		printf("[31mUsage: toptor -p [0m topology file name\n"
			   "[31m              -o [0m output file name)\n");
		exit(1);
	}
} else {
	if (argc == 2)
	if (strcmp(argv[1], "-h") == 0 || strcmp(argv[1], "-H") == 0) {
		printf("Usage: toptor -p  topology file name\n"
		       "              -o  output file name)\n");
		exit(1);
	}
	if (argc != 5) {
		printf("Usage: toptor -p  topology file name\n"
		       "              -o  output file name)\n");
		exit(1);
	}
}

for (i = 1; i < argc; i += 2) {
	if (strcmp(argv[i], "-p") == 0) 
		strcpy(pfilename, argv[i + 1]);
	if (strcmp(argv[i], "-o") == 0) 
		strcpy(ofilename, argv[i + 1]);
}
if((fptop=fopen(pfilename,"r"))==NULL) {
    	fprintf(stderr, "\n Cannot open topology file: %s, exit", pfilename);
	exit(1);
}
if((fpout=fopen(ofilename,"w"))==NULL) {
	fprintf(stderr, "\n Cannot open file to write: %s, exit", ofilename);
	exit(1);
}
rtopparm();

atom = (ATOM *) malloc(sizeof(ATOM) * (atomnum + 10));
if (atom == NULL) {
        fprintf(stderr, "memory allocation error for *atom\n");
        exit(1);
}
bond = (BOND *) malloc(sizeof(BOND) * (btnum + 10));
if (bond == NULL) {
        fprintf(stderr, "memory allocation error for *bond\n");
        exit(1);
}
angle = (ANGLE *) malloc(sizeof(ANGLE) * (atnum + 10));
if (angle == NULL) {
        fprintf(stderr, "memory allocation error for *angle\n");
        exit(1);
}
tor = (TOR *) malloc(sizeof(TOR) * (ttnum + 10));
if (tor == NULL) {
        fprintf(stderr, "memory allocation error for *tor\n");
        exit(1);
}

rewind(fptop);
rtopatom();
rewind(fptop);
rtopff();

fclose(fptop);
write();
fclose(fpout);
return(0);
}

