// vectormath.h

#define PI 3.1415926535897932384626433832795
#define FOURPI PI*4.0
#define PIOVER2 PI/2.0
#define RADDEG 57.295779513082320876798154814105
#define DEGRAD 0.017453292519943295769236907684886
#define SMALL 0.00000000000001

#define CROSS_PRODUCT(TX,TY,TZ,UX,UY,UZ,VX,VY,VZ) \
  TX = (UY*VZ) - (UZ*VY); \
  TY = (UZ*VX) - (UX*VZ); \
  TZ = (UX*VY) - (UY*VX)

void normalize(double a[3]);
void vector_sub(double V[3], double U[3], double W[3]);
void vector_sum(double V[3], double U[3], double W[3]);
double dot_product(double V[3], double U[3]);
double dot_product_angle(double V[3], double U[3]);
void matrix_transpose(double M[9], double U[9]);
void matrix_times_vector(double M[3], double R[9], double V[3]);
void matrix_multiply(double M[9], double Row[9], double Col[9]);
double matrix_to_angle(double U[9]);
int axis_of_rotation(double V[3], double U[9], double theta);
void calcRotationMatrix(double T[9], double V[3], double theta);
void calcRotationMatrix(double T[9], double psiX, double psiY, double psiZ);
int diagEsort(double *mat, double *Emat, double *Evec[], double *Eigenvalue);

void printVector(const char *Name, double V[3]);
void printMatrix(const char *Title, double U[9]);
void printRotTransInfo(double U[9], double trans[6]);

