#ifndef GLEAP_PLUGINS_CHECK_HPP
#define GLEAP_PLUGINS_CHECK_HPP

#include <guilib.hpp>

namespace amber
{

    using namespace mort;

    class check_command : public command_i
    {
    public:

        check_command();

        check_command( bool checkmolcharge,  bool checkatomparams,
                       bool checkbondparams, bool checkangleparams,
                       bool checkbondlength, bool checkatomclashes,
                       const string& molnam );

        virtual ~check_command();

        virtual bool exec();

        virtual void undo();

        virtual const char* info( ) const;

        virtual shared_ptr< command_i > clone( const vector<string>& args ) const;

    private:

        bool m_checkmolcharge;
        bool m_checkatomparams;
        bool m_checkbondparams;
        bool m_checkangleparams;
        bool m_checkbondlength;
        bool m_checkatomclashes;
        string m_molnam;

    };

} // namespace amber



#endif

