#ifndef CellManipHeadings
#define CellManipHeadings

#include "CrdManipDS.h"
#include "pmeDirectDS.h"
#include "TopologyDS.h"
#include "CellManipDS.h"
#include "CompFrcDS.h"
#include "TrajectoryDS.h"

cell CreateCell(int maxatom);

void ExtendCell(cell *C, int maxatom);

void TakeCellGridDims(int* cdim, coord *crd, dircon *dcinp);

cellgrid CreateCellGrid(coord *crd, dircon *dcinp);

void DestroyCell(cell *C);

void DestroyCellGrid(cellgrid *CG);

void AtomsToCellsOrtho(coord *crd, dircon *dcinp, cellgrid *CG, prmtop *tp);

void CopyCellContents(cellgrid *CG, int Oi, int Oj, int Ok, int Ni, int Nj,
		      int Nk, int mx, int my, int mz, int dreg, double Mcut,
		      coord *crd, prmtop *tp);

void ComputeDirectAll(cellgrid *CG, FrcTab *EFrc, dircon *dcinp, prmtop *tp);

void ShareTriple2(cellgrid *CG, double Mcut, coord *crd, prmtop *tp);

void DirectTriple2(cell *C, double* celldim, FrcTab *Etab, dircon *dcinp,
		   prmtop *tp, Energy *sysUV);

void ImportCellForces(cellgrid *CG, int Oi, int Oj, int Ok, int Ni, int Nj,
                      int Nk, int mx, int my, int mz, int dreg);

void MergeTriple2(cellgrid *CG);

void MapCellsToAtoms(cellgrid *CG, coord *crd);

void UpdateCells(cellgrid *CG, prmtop *tp);

#endif
