#ifndef CellManipStructs
#define CellManipStructs

#include "MatrixDS.h"

struct AtomInCell {
  int id;
  int lj;
  double q;
  double loc[3];
  double frc[3];
};
typedef struct AtomInCell atomc;

struct AtomInCellBuffer {
  int id;       
  double loc[3];
};
typedef struct AtomInCellBuffer atomb;

struct AtomInCellBufferPlusVelocity {
  int id;       
  double loc[3];
  double vel[3];
};
typedef struct AtomInCellBufferPlusVelocity atombv;

struct CellBlock {
  int nexp;
  int nimp;
  int maxatom;
  int CPUrank;
  int* nr;
  int* nsr;
  imat ordr;
  double orig[3];

  /*** Auxiliary arrays to store data that is not always needed ***/
  double* vel;

  /*** Atom information used during nonbonded loop.  The elements of the  ***/
  /*** map array point to regions of data, similar to a matrix structure. ***/
  atomc* data;
  atomc** map;

  /*** Buffer arrays ***/
  atomb* import;
  atomb* export;
  atombv* Vimport;
  atombv* Vexport;
};
typedef struct CellBlock cell;

struct CellBlockGrid {
  int ng[3];
  double celldim[3];
  cell* data;
  cell*** map;
};
typedef struct CellBlockGrid cellgrid;

#endif
