#ifndef ConstraintHeadings
#define ConstraintHeadings

#include "TopologyDS.h"
#include "CrdManipDS.h"
#include "TrajectoryDS.h"

/***=======================================================================***/
/*** Diagram for SETTLE:                                                   ***/
/***                                                                       ***/
/*** Oxygen at a0, hydrogens at b0, c0, center of mass at the origin.      ***/
/***                                                                       ***/
/***                   |                                                   ***/
/***                   |                                                   ***/
/***                   |                                                   ***/
/***                a0 x -----                                             ***/
/***                   |   |                                               ***/
/***                   |   ra                                              ***/
/***                   |   |                                               ***/
/*** ----------------Orig.------------------                               ***/
/***           |       |        |                                          ***/
/***           rb      |---rc---|                                          ***/
/***           |       |        |                                          ***/
/***    b0 x-----------|        c0 x                                       ***/
/***                                                                       ***/
/***=======================================================================***/

void ReimageConstraintGroup(double* x, coord *crd, int natom);

void PositionConstraints(coord *crd, prmtop *tp, double invdt);

void VelocityConstraints(coord *crd, prmtop *tp);

void VVConstraintVirial(coord *crd, prmtop *tp, trajcon *tj, Energy *sysUV);

#endif
