#ifndef IntegratorHeadings
#define IntegratorHeadings

#include "TopologyDS.h"
#include "CrdManipDS.h"
#include "CompFrcDS.h"
#include "CellManipDS.h"
#include "pmeRecipDS.h"
#include "pmeDirectDS.h"
#include "BSplineDS.h"
#include "TrajectoryDS.h"
#include "TimingsDS.h"

void AtomForces(coord *crd, cellgrid *CG, prmtop *tp, dircon *dcinp,
                FrcTab *Etab, FrcTab *EHtab, reccon *rcinp, bmap *pmmap,
		bckit *PPk, Energy *sysUV, execon *etimers);

void SumTotalEnergy(Energy *sysUV);

void InitVelocities(coord *crd, cellgrid *CG, prmtop *tp, dircon *dcinp,
                    FrcTab *Etab, FrcTab *EHtab, reccon *rcinp, bmap *pmmap,
		    bckit *PPk, trajcon *tj, Energy *sysUV, execon *etimers,
		    cdftrj* Acdf);

void Dynamics(coord *crd, cellgrid *CG, prmtop *tp, dircon *dcinp,
	      FrcTab *Etab, FrcTab *EHtab, reccon *rcinp, bmap *pmmap,
	      bckit *PPk, trajcon *tj, Energy *sysUV, execon *etimers,
	      cdftrj* Acdf);

void PrepForceReport(coord *crd, cellgrid *CG, prmtop *tp, dircon *dcinp,
                     FrcTab *Etab, FrcTab *EHtab, reccon *rcinp, bmap *pmmap,
		     bckit *PPk, trajcon *tj, execon *etimers);

#endif
