#ifndef ThermostatFunctions
#define ThermostatFunctions

#include "TrajectoryDS.h"
#include "TopologyDS.h"
#include "CrdManipDS.h"

double CurrentKineticEnergy(coord *crd, prmtop *tp);

double CurrentSystemTemperature(coord *crd, prmtop *tp, Energy *sysUV,
				int updateKE);

void BerendsenThermostat(coord *crd, prmtop *tp, trajcon *tj, Energy *sysUV);

void AndersenThermostat(coord *crd, prmtop *tp, trajcon *tj, double T);

void NHThermostat(coord *crd, prmtop *tp, trajcon *tj, Energy *sysUV,
                  double ETAt, double *CHIt, double *CHItp1e, double *CHItp1q,
                  int barostat);

void PrepThermoBarostat(prmtop *tp, trajcon *tj);

#endif
