#ifndef TopologyHeadings
#define TopologyHeadings

#include "Constants.h"
#include "TopologyDS.h"
#include "CrdManipDS.h"

void GetPrmTop(prmtop *tp, int adjbnd);

void ReadToFlag(char* fname, FILE *inp, int tryrewind);

char* LoadChar(FILE *inp, int N, int P, int Q);

int* LoadInteger(FILE *inp, int N);

double* LoadDouble(FILE *inp, int N);

prmtop CopyTopology(prmtop *tp);

void FreeTopology(prmtop *tp);

void AdjustBondArray(int* A, int N, int P);

int FindAtom(prmtop *tp, int il, int ih, char* aname);

void PutPrmTop(prmtop *tp, char* fname, char* title);

void EnumerateBonds(prmtop *tp);

void EnumerateAngles(prmtop *tp);

void EnumerateDihedrals(prmtop *tp);

void OrderParameters(prmtop *tp);

void FindThreePointWaters(prmtop *tp);

void CompSettleGeom(prmtop *tp);

int ProteinChiralityCheck(prmtop *tp, coord *tc, FILE *outp);

int FindDisulfides(prmtop *tp, coord *tc, FILE *outp);

int LocateResID(prmtop *tp, int ai, int llim, int hlim);

#endif
