#ifndef pmeRecipStructs
#define pmeRecipStructs

#include "fftw3.h"

#include "GridDS.h"
#include "mleRecipDS.h"

struct pmeRecipControlData {

  /*** Smooth particle Mesh Ewald ***/
  int ordr[3];
  int* ng;
  double S;

  /*** Multi-Level (Smooth Particle Mesh) Ewald ***/
  int nlev;
  int nslab;
  int nstrip;
  int ggordr;
  int PadYZ[4];
  int OptMesh;
  int ntrg;
  int maxiter;
  double MeshIterTol;
  double dg0;
  double mindg;
  double cfac[4];
  g2gmap* SPrv;
  g2gmap* SPcv;
  dbook* Urec;
  dbook* QL;
  fftw_plan* forwplan;
  fftw_plan* backplan;
};
typedef struct pmeRecipControlData reccon;

struct BCMeshKit {
  double SelfEcorr;
  double* Bx;
  double* By;
  double* Bz;
  double* mx;
  double* my;
  double* mz;
  double* mxs;
  double* mys;
  double* mzs;
  double* Ex;
  double* Ey;
  double* Ez;
  fftw_plan forwplan;
  fftw_plan backplan;
};
typedef struct BCMeshKit bckit;

#endif
