#define _REAL_ double precision

      subroutine amg(xm,ym,zm,nbnd,c,c2,index,index2,bv,phi,xs,EPS1)

!     EPS1 <- accept
!     bv <- f
!     phi <- u
!     xs  <- u0

      implicit none
      integer xm,ym,zm,xmymzm,nbnd
      _REAL_ :: c(xm,ym,zm,7),c2(nbnd,27)
      _REAL_ :: bv(1:xm*ym*zm)
      _REAL_ :: phi(1:xm*ym*zm),xs(1:xm*ym*zm)
      integer :: index(xm,ym,zm),index2(xm,ym,zm)
      _REAL_ EPS1

      _REAL_,allocatable :: a(:),u(:),f(:)
      integer,allocatable :: ia(:),ja(:),ig(:)
      integer NDA,NDIA,NDJA,NDU,NDF,NDIG,NNU,NNA
      integer MATRIX,IFIRST,ISWTCH,IOUT,IPRINT,IERR

      _REAL_ time1,time2
      integer ist

!     print *,'entered amg'
      
      xmymzm = xm*ym*zm

      NNU = xmymzm
      NNA = 27*nbnd+(NNU-nbnd)*7

!       read (90,*),NDA
!       allocate (A(NDA))
!       read (90,*),A

!       read (90,*),NDIA
!       allocate (IA(NDIA))
!       read (90,*),IA

!       read (90,*),NDJA
!       allocate (JA(NDJA))
!       read (90,*),JA

!       read (90,*),NDF
!       allocate (F(NDF))
!       read (90,*),F

!       read (90,*),NDU
!       allocate (U(NDU))
!       read (90,*),U

!       read (90,*),NDIG
!       allocate (IG(NDIG))
!       read (90,*),IG

      NDA = 5*NNA+5*NNU
      NDU = 3*NNU
      NDIG = 6*NNU
!
      NDA = NDA*1.2
!     NDA = NDA*2
!     NDU = NDU*1.2
!     NDIG = NDIG*1.2
!
      NDF  = NDU
      NDIA = NDU
      NDJA = NDA


!     NDA = 40*xmymzm
!     NDIA = 3*xmymzm
!     NDJA = 40*xmymzm
!     NDU = 3*xmymzm
!     NDF = 3*xmymzm
!     NDIG = 6*xmymzm
!     NNU = xmymzm

      MATRIX = 22
      IFIRST = 11
      ISWTCH = 4
      IOUT = 12
      IPRINT = 10606

!     print *,nda,ndia,ndja,ndu,ndf,ndig
      allocate ( a(1:nda), stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate a(1:nda) failed',nda,ist
         stop
      end if
      allocate ( ja(1:ndja), stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate ja(1:ndja) failed',ndja,ist
         stop
      end if
      allocate ( ia(1:ndia), stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate ia(1:ndia) failed',ndia,ist
         stop
      end if
      allocate ( u(1:ndu)  , stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate u(1:ndu)   failed',ndu,ist
         stop
      end if
      allocate ( f(1:ndf)  , stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate f(1:ndf)   failed',ndf,ist
         stop
      end if
      allocate ( ig(1:ndig), stat=ist)
      if ( ist /= 0 ) then 
         print *,'allocate ig(1:ndig) failed',ndig,ist
         stop
      end if
!     print *,'allocation success!'

!     print *,'entering seta'
      call SETA(xm,ym,zm,nbnd,index,index2,c,c2,bv,NDA,NDU,NNU,a, f, ia, ja)

      u(1:xmymzm) = xs(1:xmymzm)

      call wallclock(time1)
!     print *, 'entering aux1r5'
      CALL AUX1R5(A,IA,JA,U,F,IG, &
                  NDA,NDIA,NDJA,NDU,NDF,NDIG,NNU,MATRIX,&
                  EPS1,IFIRST,ISWTCH,IOUT,IPRINT,&
                  IERR)
      call wallclock(time2)
!     write (6,*) "AMG time",time2-time1

      xs(1:xmymzm) = u(1:xmymzm)
      phi(1:xmymzm) = u(1:xmymzm)

      deallocate(a,ia,ja)
      deallocate(u)
      deallocate(f)
      deallocate(ig)

      contains

      subroutine SETA(l,m,n,maxirr,index,index2,c,c2, &
                 ff,NDA,NDU,NNU,a,f,ia,ja)

!     dimension uu(0:l+1,0:m+1,0:n+1)	
      implicit none
      integer l,m,n,maxirr,NDA,NDU,NNU
      integer :: index(l,m,n), index2(l,m,n)
      _REAL_ :: c(l,m,n,7), c2(maxirr,27)
      _REAL_ :: ff(l,m,n)
      _REAL_ :: a(NDA),f(NDU)
      integer :: ia(NDU), ja(NDA)

      integer ncount,i,j,k,ne,ii,ir,nc1,i0,j0,k0,ndis
      
!     print *,'entered seta'
      ncount = 0
      
      do k=1, n
         do j=1, m
            do i=1, l
!              print *,i,j,k
               if (index(i,j,k).eq.1 .or. index(i,j,k).eq.5) then
!                 print *,'entered if'
                  ne = npos(l,m,n,i,j,k)
!                 print *,'1'
                  ncount = ncount + 1
!                 print *,'2'
                  a(ncount) = c(i,j,k,1)
!                 print *,'3'
                  ia(ne) = ncount
!                 print *,'4'
                  ja(ncount)=ne
!                 print *,'5'
                  f(ne) = ff(i,j,k)
!                 print *,'6'

!                 print *,c(i,j,k,1:7),f(ne)

                  if ( c(i,j,k,2) > 1.d-10 ) then 
                     ne = npos(l,m,n,i-1, j, k)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,2)
                     ja(ncount)=ne
                  end if 

                  if ( c(i,j,k,3) > 1.d-10 ) then 
                     ne = npos(l,m,n,i+1, j, k)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,3)
                     ja(ncount)=ne
                  end if 

                  if ( c(i,j,k,4) > 1.d-10 ) then 
                     ne = npos(l,m,n,i, j-1, k)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,4)
                     ja(ncount)=ne
                  end if 

                  if ( c(i,j,k,5) > 1.d-10 ) then 
                     ne = npos(l,m,n,i, j+1, k)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,5)
                     ja(ncount)=ne
                  end if 

                  if ( c(i,j,k,6) > 1.d-10 ) then 
                     ne = npos(l,m,n,i, j, k-1)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,6)
                     ja(ncount)=ne
                  end if 

                  if ( c(i,j,k,7) > 1.d-10 ) then 
                     ne = npos(l,m,n,i, j, k+1)
                     ncount = ncount + 1
                     a(ncount) = -c(i,j,k,7)
                     ja(ncount)=ne
                  end if

! WJ
!                 ne = npos(l,m,n,i, j, k)
!                 write(190,*) '++++',i,j,k,ne,'+++++++++'
!                 write(190,*) c(i,j,k,1:7)
!                 do ii=ia(ne),ncount
!                    write(190,*) a(ii),ja(ii)
!                 end do
!                 write(190,*) f(ne)
 
                
               else
                   
                  ir = index2(i,j,k)
                  ne = npos(l,m,n,i,j,k)
                  ncount = ncount + 1
                  a(ncount) = -c2(ir,14)
                  ia(ne) = ncount
                  ja(ncount)=ne
                  f(ne) = -ff(i,j,k)
                  
                  nc1 = 0
                  do i0 = i-1, i+1
                  do j0 = j-1, j+1
                  do k0 = k-1, k+1
                     ndis=abs(i-i0)+abs(j-j0)+abs(k-k0)
                     if (ndis .eq. 0) then 
                       nc1 = nc1 + 1
                     else
                       nc1 = nc1 + 1
                       ne = npos(l,m,n,i0,j0,k0)
                       ncount = ncount + 1
                       a(ncount) = -c2(ir,nc1)
                       ja(ncount) = ne
                     endif
                  end do
                  end do
                  end do
! WJ
!                 ne = npos(l,m,n,i, j, k)
!                 write (190,'(3i5,$)'),i,j,k
!                 write (190,*),"IRREGULAR"
!                 do ii=ia(ne),ncount
!                    write(190,'(f20.10,$)') a(ii)
!                 end do
!                 write(190,'(f20.10)') f(ne)
!
                
               endif
            end do
         end do
      end do
      
      ia(NNU+1) = ncount + 1
   
      return
      end subroutine SETA
        
      integer function npos(l,m,n,i,j,k)
      implicit none
         integer l,m,n,i,j,k
         npos = i + (j-1)*l + (k-1)*l*m 
         return
      end function npos

      end subroutine amg
