#!/bin/bash

. ../MasterTest.sh

# Clean
CleanFiles closest.in Closest.pdb closest2.in first.Closest.pdb closestmols.dat closest.ChainA-tip3p.parm7

# Test 1
CheckNetcdf
cat > closest.in <<EOF
noprogress
parm ../ChainA-tip3p.parm7
trajin ../run0.nc 1 1
closest 10 :1-268 first closestout closestmols.dat outprefix closest
trajout first.Closest.pdb pdb
EOF
INPUT="-i closest.in"
RunCpptraj "Closest command test using first solvent atom."
DoTest first.Closest.pdb.save first.Closest.pdb
DoTest closestmols.dat.save closestmols.dat
DoTest closest.ChainA-tip3p.parm7.save closest.ChainA-tip3p.parm7

# Long test, disabled for now.
#cat > closest2.in <<EOF
#noprogress
#parm ../ChainA-tip3p.parm7
#trajin ../run0.nc 1 1
#closest 10 :1-268
#trajout Closest.pdb pdb
#EOF
#INPUT="-i closest2.in"
#RunCpptraj "Closest command test using all solvent atoms."
#DoTest Closest.pdb.save Closest.pdb

CheckTest

EndTest

exit 0
