#!/bin/bash

. ../MasterTest.sh

# Clean
CleanFiles strip.in *.ChainA-tip3p.parm7 Complex.crd Receptor.crd Ligand.crd

# Test 1
cat > strip.in <<EOF
noprogress
parm ../ChainA-tip3p.parm7
trajin ../ptraj.run0.crd 1 1 parm ../ChainA-tip3p.parm7

# Count res 272 as ligand, 1-268 as receptor, 1-268,272 as complex

# Complex
strip :269-271,273-15290 outprefix complex
outtraj Complex.crd
unstrip

# Receptor
strip :WAT outprefix receptor
outtraj Receptor.crd
unstrip

# Ligand
strip !(:272) outprefix ligand
outtraj Ligand.crd
EOF
INPUT="-i strip.in"
RunCpptraj "Unstrip (Lig/Rec/Complex) command test."
DoTest strip.ChainA-tip3p.parm7.save complex.ChainA-tip3p.parm7
DoTest receptor.ChainA-tip3p.parm7.save receptor.ChainA-tip3p.parm7
DoTest ligand.ChainA-tip3p.parm7.save ligand.ChainA-tip3p.parm7
DoTest Ligand.crd.save Ligand.crd 
CheckTest

EndTest

exit 0
