#!/bin/sh
/bin/rm -f water.mol wat2.mol2

cat > leap.in << EOF

set default echo on

o  = createatom O  OW -0.834
h1 = createatom H1 HW  0.417
h2 = createatom H2 HW  0.417

ocopy  = copy o
h1copy = copy h1
h2copy = copy h2

set ocopy  position { 1.000 1.000 1.000 }
set h1copy position { 2.000 2.000 2.000 }
set h2copy position { 3.000 3.000 3.000 }


set o  element O
set h1 element H
set h2 element H

set o  position { 0.000 0.000  0.000 }
set h1 position { 0.000 0.857  0.222 }
set h2 position { 0.000 0.858 -0.222 }

bond h1 o
bond h2 o
bond h1 h2

r = createresidue TIP3
add r o
add r h1
add r h2

TIP3 = createunit TIP3

add TIP3 r

TIP3c = copy TIP3

set TIP3c.1.O  position { 1.000 0.000 0.000 }
set TIP3c.1.H1 position { 2.000 2.000 0.000 }
set TIP3c.1.H2 position { 3.000 3.000 3.000 }

set TIP3c.1.O  charge -1.000
set TIP3c.1.H1 charge  0.500
set TIP3c.1.H2 charge  0.500


savemol2 TIP3 water.mol2

savemol2 TIP3c wat2.mol2


quit
EOF

../../../bin/sleap < leap.in  > leap.out
../dacdif water.mol2.save water.mol2
../dacdif wat2.mol2.save wat2.mol2
/bin/rm -f leap.in


